//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame   = PERIOD_CURRENT;
extern int                ZlEmaPeriod = 14;
extern ENUM_APPLIED_PRICE ZlEmaPrice  = PRICE_CLOSE;
extern bool               Interpolate = true;
double price[];
double zl[];

string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
      SetIndexBuffer(0,zl);
      SetIndexBuffer(1,price);

      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99;
      TimeFrame         = MathMax(TimeFrame,_Period);
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { zl[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
    
   if (TimeFrame == Period())
   {
      double alpha = 2.0/(ZlEmaPeriod+1.0);
      int    lag   = (ZlEmaPeriod-1.0)/2.0;
         for(int i = limit; i >= 0; i--)
         {
            price[i] = iMA(NULL,0,1,0,MODE_SMA,ZlEmaPrice,i);
            zl[i]    = zl[i+1]+alpha*(price[i]+(price[i]-price[i+lag])-zl[i+1]);
         }
      return(0);
   }

   //
   //
   //
   //
   //
      
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         zl[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,ZlEmaPeriod,ZlEmaPrice,0,y);
         if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

            datetime time = iTime(NULL,TimeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(int k = 1; k < n; k++)
                  zl[i+k] = zl[i] + (zl[i+n] - zl[i])*k/n;
   }
   return(0);
}